# figure out if we have to add the performance directory name
.find_path_prefix: &find_path_prefix
  - >
      if [ -d "$TB_PATH/$C_PATH" ]; 
      then 
        C_PATH="$TB_PATH/$C_PATH"
      fi

# If Google Test doesn't exist then get the files
.get_googletest: &get_googletest
  - >
      if [ ! -d "$C_PATH/$GOOGLE_TEST/" ];
      then
        git clone https://github.com/google/googletest.git "$C_PATH/$GOOGLE_TEST/"
      fi

.define_question_dir: &define_question_dir
  TB_PROJECT_DIR: "/builds/90cos/cyv/Private-test-bank/basic-dev"
  TB_PATH: performance
  GOOGLE_TEST: googletest

# JOB DEFINITIONS
Build_C_Question_array_manipulate:
  image: registry.gitlab.com/90cos/docker-definitions/basic-dev
  stage: build
  variables:
    <<: *define_question_dir
    C_PATH: C_Programming/array_manipulate
  script:
    - *find_path_prefix
    - *get_googletest
    - cd $C_PATH
    - mkdir build
    - cmake -S . -B build/
    - make -C build/
    - pwd
    - ls
  artifacts:
    paths:
      - ${C_PATH}/build/TestCode
      - $TB_PATH/$C_PATH/build/TestCode
    expire_in: 1 day
  rules:
    - if: '$CI_PROJECT_NAME != "basic-dev"'
    - if: '$CI_PROJECT_NAME == "basic-dev"'
      changes:
      - performance/C_Programming/array_manipulate/**/*

Test_C_Question_array_manipulate:
  image: registry.gitlab.com/90cos/docker-definitions/basic-dev
  stage: test
  variables:
    <<: *define_question_dir
    C_PATH: C_Programming/array_manipulate
  needs:
    - Build_C_Question_array_manipulate
  script:
    - *find_path_prefix
    - *get_googletest
    - cd $C_PATH
    - ./build/TestCode
  rules:
    - if: '$CI_PROJECT_NAME != "basic-dev"'
    - if: '$CI_PROJECT_NAME == "basic-dev"'
      changes:
      - performance/C_Programming/array_manipulate/**/*
